


dnl MC_CHECK_VERSION(given-version, required-version [, match-action] [, else-action])
AC_DEFUN(MC_CHECK_VERSION,[
[eval `echo "$1:0:0:0:0:0:0" | sed -e 's/^[^0-9]*//' -e 's/[^0-9]\+/:/g' \
 -e 's/\([^:]*\):\([^:]*\):\([^:]*\):\([^:]*\):\([^:]*\):.*/ac_v1=\1 ac_v2=\2 ac_v3=\3 ac_v4=\4 ac_v5=\5 ac_v6=0/' \
`]
[eval `echo "$2:0:0:0:0:0:0" | sed -e 's/^[^0-9]*//' -e 's/[^0-9]\+/:/g' \
 -e 's/\([^:]*\):\([^:]*\):\([^:]*\):\([^:]*\):\([^:]*\):.*/ac_r1=\1 ac_r2=\2 ac_r3=\3 ac_r4=\4 ac_r5=\5 ac_r6=0/' \
`]
ac_vm=[`expr \( $ac_v1 \> $ac_r1 \) \| \( \( $ac_v1 \= $ac_r1 \) \& \(		\
	      \( $ac_v2 \> $ac_r2 \) \| \( \( $ac_v2 \= $ac_r2 \) \& \(		\
	       \( $ac_v3 \> $ac_r3 \) \| \( \( $ac_v3 \= $ac_r3 \) \& \(	\
	        \( $ac_v4 \> $ac_r4 \) \| \( \( $ac_v4 \= $ac_r4 \) \& \(	\
	         \( $ac_v5 \> $ac_r5 \) \| \( \( $ac_v5 \= $ac_r5 \) \& \(	\
	          \( $ac_v6 \>= $ac_r6 \)					\
		 \) \)	\
		\) \)	\
	       \) \)	\
	      \) \)	\
	     \) \)	`]
case $ac_vm in
[1)]
	[$3]
	;;
*[)]
	[$4]
	;;
esac
])

dnl Check whether cc accepts a certain option
dnl DB_TEST_LIBGLADE(version, [success-action [, failure-action]])
AC_DEFUN(DB_TEST_LIBGLADE,[
  AC_PATH_PROG(LIBGLADE_CONFIG, libglade-config, no)
  AC_MSG_CHECKING(for libglade)
  if test "$LIBGLADE_CONFIG" = "no"; then
    AC_MSG_RESULT(no)
    [$3]
  else
    LIBGLADE_VERSION=`$LIBGLADE_CONFIG --version | sed -e 's/libglade //;' `
    MC_CHECK_VERSION($LIBGLADE_VERSION, $1,
LIBGLADE_LIBS=`$LIBGLADE_CONFIG --libs`
LIBGLADE_CFLAGS=`$LIBGLADE_CONFIG --cflags`
dnl AC_MSG_RESULT(yes)
$2,
AC_MSG_RESULT(no, wrong version); $3)
  fi
])

dnl DB_TEST_LIBXML(version, success, failure)
AC_DEFUN(DB_TEST_LIBXML,[
  AC_PATH_PROG(XML_CONFIG, xml-config, no)
  AC_MSG_CHECKING(for libxml)
  if test "$XML_CONFIG" = "no"; then
    AC_PATH_PROG(GNOME_CONFIG, gnome-config, no)
    if test "$GNOME_CONFIG" != "no" ; then
      if $GNOME_CONFIG xml | grep -qi \^Unknown ; then
        AC_MSG_RESULT(no)
      else
        XML_CONFIG="$GNOME_CONFIG xml"
        AC_MSG_RESULT(yes)
      fi
    else
      AC_MSG_RESULT(no)
    fi
  elif test "x$XML_CONFIG" != "x"; then
    AC_MSG_RESULT(yes)
  fi;

  if test "x$XML_CONFIG" = "xno"; then
  	/bin/true
  else
    XML_VERSION=`$XML_CONFIG --version | sed -e "s/libxml //;" `
    XML_CFLAGS=`$XML_CONFIG --cflags`
    XML_LIBS=`$XML_CONFIG --libs`
    MC_CHECK_VERSION($XML_VERSION, $1, $2, $3)
  fi
])

