#ifndef __CLI_H_
#define __CLI_H_

typedef struct _CliInfo CliInfo;
#include "linetokenizer.h"
#include <gdam/client/gdamchannel.h>
#include <gdam/common/gdam-protocol.h>
#include <gdam/common/gdamarg.h>

struct _CliInfo 
{
  GdamChannel* 		channel;
  int 			device_id;
  int 			mixer_id;
  unsigned 		interactive : 1;
  unsigned 		exit_on_error : 1;
  gboolean*		is_done_processing;

  GHashTable*		id_to_type;
  GStringChunk*		const_type_names;
};

void        cli_info_set_id_type   (CliInfo*        cli_info,
                                    int             id,
				    const char*     type);
const char* cli_info_get_type_by_id(CliInfo*        cli_info,
                                    int             id);

#endif
