/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __LINE_TOKENIZER_H_
#define __LINE_TOKENIZER_H_

#include <gdam/common/gdamarg.h>
#include "arghints.h"

typedef struct _LineTokenizer LineTokenizer;

struct _LineTokenizer {
	const char*             line;
	const char*             at;

	/* String mapping to apply on $ variables. */
	GHashTable*		variables;

	/* Global table of "hints" about types of various named arguments */
	ArgHintsTable*          hint_table;
};

LineTokenizer* line_tokenizer_new        (const char*      line);
char*          line_tokenizer_get_word   (LineTokenizer*   tokenizer);
gboolean       line_tokenizer_tokenize   (LineTokenizer*   tokenizer,
					  ArgHints*        arg_hints,
                                          GdamArg*         arg);
void           line_tokenizer_destroy    (LineTokenizer*   tokenizer);

#endif
