#include "gdamarg.h"

int main(int argc, char** argv)
{
  GdamArg arg;

  arg.type = GDAM_ARG_TYPE_INT;
  g_assert (gdam_arg_parse_val_from_string (&arg, "1") > 0);
  g_assert (GDAM_ARG_INT (&arg) == 1);

  arg.type = GDAM_ARG_TYPE_INT64;
  g_assert (gdam_arg_parse_val_from_string (&arg, "100000") > 0);
  g_assert (GDAM_ARG_INT64 (&arg) == 100000);

  arg.type = GDAM_ARG_TYPE_DOUBLE;
  g_assert (gdam_arg_parse_val_from_string (&arg, "1") > 0);
  g_assert (GDAM_ARG_DOUBLE (&arg) == 1);
  g_assert (gdam_arg_parse_val_from_string (&arg, "0.5") > 0);
  g_assert (GDAM_ARG_DOUBLE (&arg) == 0.5);
  g_assert (gdam_arg_parse_val_from_string (&arg, "-1") > 0);
  g_assert (GDAM_ARG_DOUBLE (&arg) == -1);
  g_assert (gdam_arg_parse_val_from_string (&arg, "-3") > 0);
  g_assert (GDAM_ARG_DOUBLE (&arg) == -3);

  arg.type = GDAM_ARG_TYPE_INT_ARRAY;
  g_assert (gdam_arg_parse_val_from_string (&arg, "[]") > 0);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).length == 0);
  g_free (GDAM_ARG_INT_ARRAY (&arg).array);
  g_assert (gdam_arg_parse_val_from_string (&arg, "[42]") > 0);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).length == 1);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).array[0] == 42);
  g_free (GDAM_ARG_INT_ARRAY (&arg).array);
  g_assert (gdam_arg_parse_val_from_string (&arg, "[42 84 6 101 3]") > 0);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).length == 5);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).array[0] == 42);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).array[1] == 84);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).array[2] == 6);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).array[3] == 101);
  g_assert (GDAM_ARG_INT_ARRAY (&arg).array[4] == 3);
  g_free (GDAM_ARG_INT_ARRAY (&arg).array);

  arg.type = GDAM_ARG_TYPE_INT64_ARRAY;
  g_assert (gdam_arg_parse_val_from_string (&arg, "[]") > 0);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).length == 0);
  g_free (GDAM_ARG_INT64_ARRAY (&arg).array);
  g_assert (gdam_arg_parse_val_from_string (&arg, "[42]") > 0);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).length == 1);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).array[0] == 42);
  g_free (GDAM_ARG_INT64_ARRAY (&arg).array);
  g_assert (gdam_arg_parse_val_from_string (&arg, "[42 84 6 101 3]") > 0);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).length == 5);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).array[0] == 42);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).array[1] == 84);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).array[2] == 6);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).array[3] == 101);
  g_assert (GDAM_ARG_INT64_ARRAY (&arg).array[4] == 3);
  g_free (GDAM_ARG_INT64_ARRAY (&arg).array);

  arg.type = GDAM_ARG_TYPE_DOUBLE_ARRAY;
  g_assert (gdam_arg_parse_val_from_string (&arg, "[]") > 0);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).length == 0);
  g_free (GDAM_ARG_DOUBLE_ARRAY (&arg).array);
  g_assert (gdam_arg_parse_val_from_string (&arg, "[42]") > 0);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).length == 1);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).array[0] == 42);
  g_free (GDAM_ARG_DOUBLE_ARRAY (&arg).array);
  g_assert (gdam_arg_parse_val_from_string (&arg, "[42 84 6 101 3]") > 0);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).length == 5);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).array[0] == 42);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).array[1] == 84);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).array[2] == 6);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).array[3] == 101);
  g_assert (GDAM_ARG_DOUBLE_ARRAY (&arg).array[4] == 3);
  g_free (GDAM_ARG_DOUBLE_ARRAY (&arg).array);
  return 0;
}
