#include "gdamxmlinfo.h"

/*                             gdam_xml_info_*
 */
GdamXmlInfo* gdam_xml_info_new()
{
  GdamXmlInfo *info;
  info = g_new (GdamXmlInfo, 1);
  info->object_to_id = g_hash_table_new (NULL, NULL);
  info->id_to_object = g_ptr_array_new ();
  g_ptr_array_add (info->id_to_object, NULL);
  return info;
}
void gdam_xml_info_destroy(GdamXmlInfo* info)
{
  g_return_if_fail (info != NULL);
  g_hash_table_destroy (info->object_to_id);
  g_ptr_array_free (info->id_to_object, TRUE);
  g_free (info);
}

int gdam_xml_info_lookup_by_object(GdamXmlInfo* xml_info, gpointer object)
{
  gpointer pointer;
  pointer = g_hash_table_lookup (xml_info->object_to_id, object);
  if (pointer == NULL)
    return 0;
  return GPOINTER_TO_INT (pointer);
}

gpointer gdam_xml_info_lookup_by_id(GdamXmlInfo* xml_info, int id)
{
  if (id <= 0 || id >= (int) xml_info->id_to_object->len)
    return NULL;
  return g_ptr_array_index (xml_info->id_to_object, id);
}

void gdam_xml_info_assoc(GdamXmlInfo* info, int id, gpointer ptr)
{
  int old_len = info->id_to_object->len;
  if (id >= old_len)
    g_ptr_array_set_size (info->id_to_object, id + 1);
  g_ptr_array_index (info->id_to_object, id) = ptr;
  g_hash_table_insert (info->object_to_id, ptr, GINT_TO_POINTER (id));
}

int gdam_xml_info_alloc_id(GdamXmlInfo* xml_info, gpointer ptr)
{
  int id = xml_info->id_to_object->len;
  gdam_xml_info_assoc (xml_info, id, ptr);
  return id;
}
