/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __COMPONENT_FILTER_BALANCE_H_
#define __COMPONENT_FILTER_BALANCE_H_

#include "../gdamfilter.h"

typedef struct _GdamBalance GdamBalance;
typedef struct _GdamBalanceClass GdamBalanceClass;

GtkType gdam_balance_get_type();
#define GDAM_TYPE_BALANCE			(gdam_balance_get_type ())
#define GDAM_BALANCE(obj)			(GTK_CHECK_CAST ((obj), GDAM_TYPE_BALANCE, GdamBalance))
#define GDAM_BALANCE_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_BALANCE, GdamBalanceClass))
#define GDAM_IS_GAIN(obj)		(GTK_CHECK_TYPE ((obj), GDAM_TYPE_BALANCE))
#define GDAM_IS_GAIN_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_BALANCE))

struct _GdamBalanceClass {
	GdamFilterClass		filter_class;
	void			(*volume_ll_changed)  (GdamBalance*  balance);
	void			(*volume_lr_changed)  (GdamBalance*  balance);
	void			(*volume_rl_changed)  (GdamBalance*  balance);
	void			(*volume_rr_changed)  (GdamBalance*  balance);
};

struct _GdamBalance {
	GdamFilter		filter;
    	gdouble			volumes[4];

	/* An idle thread used to queue to "volume changed" requests. */
	int			idle_id;
};

GdamBalance*	gdam_balance_new	();
void		gdam_balance_set_volume(GdamBalance*		balance,
					int                     input_channel,
					int                     output_channel,
                                        gdouble                 new_vol);

#endif
