/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_CORE_MIDI_DEVICE_H_
#define __GDAM_CORE_MIDI_DEVICE_H_

#if HAVE_COREMIDI_COREMIDI_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GdamCoreMidiDevice GdamCoreMidiDevice;
typedef struct _GdamCoreMidiDeviceClass GdamCoreMidiDeviceClass;

#include "gdammididevice.h"

GtkType gdam_core_midi_device_get_type();
#define GDAM_TYPE_CORE_MIDI_DEVICE			(gdam_core_midi_device_get_type ())
#define GDAM_CORE_MIDI_DEVICE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_CORE_MIDI_DEVICE, GdamCoreMidiDevice))
#define GDAM_CORE_MIDI_DEVICE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_CORE_MIDI_DEVICE, GdamCoreMidiDeviceClass))
#define GDAM_IS_CORE_MIDI_DEVICE(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_CORE_MIDI_DEVICE))
#define GDAM_IS_CORE_MIDI_DEVICE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_CORE_MIDI_DEVICE))

#include <CoreMIDI/CoreMIDI.h>

struct _GdamCoreMidiDeviceClass {
	GdamMidiDeviceClass	midi_device_class;
};


/*=====================================================================*
 *                            GdamCoreMidiDevice                       *
 *                                                                     *
 * One source MidiEnpoint as presented by OS X CoreMidi API            *
 *=====================================================================*/
struct _GdamCoreMidiDevice {
	GdamMidiDevice	        object;

        /* Represents one source of 16 channels of midi data. */
        MIDIEndpointRef         endpoint_ref;

        /* This port allows us to receive data from one or more endpoints */
        MIDIPortRef             in_port;

	int			data_read_fd;
	int			data_write_fd;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif  /* HAVE_COREMIDI_COREMIDI_H */

#endif
