/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_FEEDBACK_FILTER_H_
#define __GDAM_FEEDBACK_FILTER_H_


typedef struct _GdamFeedbackFilter GdamFeedbackFilter;
typedef struct _GdamFeedbackFilterClass GdamFeedbackFilterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamfilter.h"

GtkType gdam_feedback_filter_get_type();
#define GDAM_TYPE_FEEDBACK_FILTER			(gdam_feedback_filter_get_type ())
#define GDAM_FEEDBACK_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_FEEDBACK_FILTER, GdamFeedbackFilter))
#define GDAM_FEEDBACK_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_FEEDBACK_FILTER, GdamFeedbackFilterClass))
#define GDAM_IS_FEEDBACK_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_FEEDBACK_FILTER))
#define GDAM_IS_FEEDBACK_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_FEEDBACK_FILTER))

struct _GdamFeedbackFilterClass {
	GdamFilterClass		filter_class;
};
struct _GdamFeedbackFilter {
	GdamFilter			filter;

	int				delay;
	gdouble				gain;
	gdouble				input_gain;
	float				beat_factor;

	/* Where we are feeding sound to/from. */
	GdamFeedbackFilter*		dest;
	guint				dest_destroy_id;
	GdamFeedbackFilter*		source;
	guint				source_destroy_id;
};

void gdam_feedback_filter_set_dest  (GdamFeedbackFilter* filter,
                                     GdamFeedbackFilter* dest);
void gdam_feedback_filter_set_source(GdamFeedbackFilter* filter,
                                     GdamFeedbackFilter* dest);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
