/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_FESTIVAL_H_
#define __GDAM_FESTIVAL_H_


typedef struct _GdamFestival GdamFestival;
typedef struct _GdamFestivalClass GdamFestivalClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamproducer.h"

GtkType gdam_festival_get_type();
#define GDAM_TYPE_FESTIVAL			(gdam_festival_get_type ())
#define GDAM_FESTIVAL(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_FESTIVAL, GdamFestival))
#define GDAM_FESTIVAL_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_FESTIVAL, GdamFestivalClass))
#define GDAM_IS_FESTIVAL(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_FESTIVAL))
#define GDAM_IS_FESTIVAL_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_FESTIVAL))

struct _GdamFestivalClass {
	GdamProducerClass	producer_class;
};
struct _GdamFestival {
	GdamProducer		producer;
	char*			text;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
