/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_FILTER_VIBRATO_H_
#define __GDAM_FILTER_VIBRATO_H_


typedef struct _GdamFilterVibrato GdamFilterVibrato;
typedef struct _GdamFilterVibratoClass GdamFilterVibratoClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "gdamfilterwavetable.h"

GtkType gdam_filter_vibrato_get_type();
#define GDAM_TYPE_FILTER_VIBRATO			(gdam_filter_vibrato_get_type ())
#define GDAM_FILTER_VIBRATO(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_FILTER_VIBRATO, GdamFilterVibrato))
#define GDAM_FILTER_VIBRATO_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_FILTER_VIBRATO, GdamFilterVibratoClass))
#define GDAM_IS_FILTER_VIBRATO(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_FILTER_VIBRATO))
#define GDAM_IS_FILTER_VIBRATO_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_FILTER_VIBRATO))

struct _GdamFilterVibratoClass {
	GdamFilterWavetableClass	filter_wavetable_class;
	void                          (*rates_changed)(GdamFilterVibrato*);
};
struct _GdamFilterVibrato {
	GdamFilterWavetable		filter_wavetable;

	gdouble				min_rate, max_rate;
};

void gdam_filter_vibrato_rates_changed(GdamFilterVibrato *);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
