/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/

#include "gdampowerspectrum.h"

static void gdam_power_spectrum_init(GdamPowerSpectrum* power_spectrum)
{
}

static void gdam_power_spectrum_class_init(GdamMeterClass* meter_class)
{
  meter_class->server_class_name = "GdasPowerSpectrum";
}

GtkType gdam_power_spectrum_get_type()
{
  static GtkType power_spectrum_type = 0;
  if (!power_spectrum_type)
    {
      static const GtkTypeInfo power_spectrum_info = {
	"GdamPowerSpectrum",
	sizeof (GdamPowerSpectrum),
	sizeof (GdamPowerSpectrumClass),
	(GtkClassInitFunc) gdam_power_spectrum_class_init,
	(GtkObjectInitFunc) gdam_power_spectrum_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      GtkType parent = GDAM_TYPE_METER;
      power_spectrum_type = gtk_type_unique (parent, &power_spectrum_info);
    }
  return power_spectrum_type;
}
