/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_POWER_SPECTRUM_H_
#define __GDAM_POWER_SPECTRUM_H_


typedef struct _GdamPowerSpectrum GdamPowerSpectrum;
typedef struct _GdamPowerSpectrumClass GdamPowerSpectrumClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "gdammeter.h"

GtkType gdam_power_spectrum_get_type();
#define GDAM_TYPE_POWER_SPECTRUM			(gdam_power_spectrum_get_type ())
#define GDAM_POWER_SPECTRUM(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_POWER_SPECTRUM, GdamPowerSpectrum))
#define GDAM_POWER_SPECTRUM_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_POWER_SPECTRUM, GdamPowerSpectrumClass))
#define GDAM_IS_POWER_SPECTRUM(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_POWER_SPECTRUM))
#define GDAM_IS_POWER_SPECTRUM_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_POWER_SPECTRUM))

struct _GdamPowerSpectrumClass {
	GdamMeterClass	meter_class;
};
struct _GdamPowerSpectrum {
	GdamMeter		meter;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
