/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_PRODUCER_MP3_CLICK_H_
#define __GDAM_PRODUCER_MP3_CLICK_H_

typedef struct _GdamProducerMp3ClickClass GdamProducerMp3ClickClass;
typedef struct _GdamProducerMp3Click GdamProducerMp3Click;

#include "../gdamsongdatabase.h"
#include "../gdamproducer.h"

GtkType gdam_producer_mp3_click_get_type();
#define GDAM_TYPE_PRODUCER_MP3_CLICK              (gdam_producer_mp3_click_get_type ())
#define GDAM_PRODUCER_MP3_CLICK(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_PRODUCER_MP3_CLICK, GdamProducerMp3Click))
#define GDAM_PRODUCER_MP3_CLICK_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PRODUCER_MP3_CLICK, GdamProducerMp3ClickClass))
#define GDAM_IS_PRODUCER_MP3_CLICK(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_PRODUCER_MP3_CLICK))
#define GDAM_IS_PRODUCER_MP3_CLICK_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PRODUCER_MP3_CLICK))


struct _GdamProducerMp3ClickClass {
	GdamProducerClass 	producer_class;
};

struct _GdamProducerMp3Click {
	GdamProducer		producer;
	char*                   filename;
	GdamSongDatabase*       song_database;
	int			buffer_size;
	int			fade_envelope;
	int			mp3_id;
	int			fader_id;
	gboolean		non_seekable;
	gdouble			click_volume;
	gdouble			last_play_position;

	int			num_beats;
	gdouble*		beat_times;
	int 			position_sub_id;
};

GdamProducerMp3Click* gdam_producer_mp3_click_new(GdamChannel*channel);
void gdam_producer_mp3_click_set_filename
                                   (GdamProducerMp3Click* producer_mp3_click,
				    const char* 	filename);
void gdam_producer_mp3_click_set_buffer_size
                                   (GdamProducerMp3Click* producer_mp3_click,
                                    int              buffer_size);
void gdam_producer_mp3_click_set_beat_times
                                   (GdamProducerMp3Click* producer_mp3_click,
                                    int                   num_beats,
                                    const gdouble*        beats);

#endif
