/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_PRODUCER_WAVETABLE_H_
#define __GDAM_PRODUCER_WAVETABLE_H_

#include <gdam/component/gdamproducer.h>

typedef struct _GdamProducerWavetable GdamProducerWavetable;
typedef struct _GdamProducerWavetableClass GdamProducerWavetableClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_producer_wavetable_get_type();
#define GDAM_TYPE_PRODUCER_WAVETABLE			(gdam_producer_wavetable_get_type ())
#define GDAM_PRODUCER_WAVETABLE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_PRODUCER_WAVETABLE, GdamProducerWavetable))
#define GDAM_PRODUCER_WAVETABLE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PRODUCER_WAVETABLE, GdamProducerWavetableClass))
#define GDAM_IS_PRODUCER_WAVETABLE(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_PRODUCER_WAVETABLE))
#define GDAM_IS_PRODUCER_WAVETABLE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PRODUCER_WAVETABLE))

struct _GdamProducerWavetableClass {
	GdamProducerClass		producer_wavetable_class;
	void     (*rate_changed)       (GdamProducerWavetable*   wavetable);
};

struct _GdamProducerWavetable {
	GdamProducer			producer_wavetable;

	gdouble				hertz;
	gdouble				rate;
	int				buffer_length;
	int				buffer_id;
	gboolean			terminates;
};

void gdam_producer_wavetable_set_buffer_id(GdamProducerWavetable* wavetable,
                                           int                    buffer_id);
void gdam_producer_wavetable_set_frequency(GdamProducerWavetable* wavetable,
                                           gdouble                hertz);
void gdam_producer_wavetable_set_rate     (GdamProducerWavetable* wavetable,
                                           gdouble                rate);


void gdam_producer_wavetable_frequency_changed(GdamProducerWavetable*);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif

