/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_PS2_KEYBOARD_H_
#define __GDAM_PS2_KEYBOARD_H_


typedef struct _GdamPs2Keyboard GdamPs2Keyboard;
typedef struct _GdamPs2KeyboardClass GdamPs2KeyboardClass;

#include "../gdaminputdevicefile.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_ps2_keyboard_get_type();
#define GDAM_TYPE_PS2_KEYBOARD			(gdam_ps2_keyboard_get_type ())
#define GDAM_PS2_KEYBOARD(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_PS2_KEYBOARD, GdamPs2Keyboard))
#define GDAM_PS2_KEYBOARD_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PS2_KEYBOARD, GdamPs2KeyboardClass))
#define GDAM_IS_PS2_KEYBOARD(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_PS2_KEYBOARD))
#define GDAM_IS_PS2_KEYBOARD_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PS2_KEYBOARD))

typedef struct _GdamPs2KeyboardEvent GdamPs2KeyboardEvent;
struct _GdamPs2KeyboardEvent {
	GdamInputEvent		event;
	const char*		name;
	int 			scancode;
};

int gdam_ps2_keyboard_press_event_get_type();
int gdam_ps2_keyboard_release_event_get_type();

struct _GdamPs2KeyboardClass {
	GdamInputDeviceFileClass		input_device_file_class;
};
struct _GdamPs2Keyboard {
	GdamInputDeviceFile		input_device_file;
	gboolean			next_is_release;
	gboolean			state_table[256];
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
