/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_RANGE_FINDER_H_
#define __GDAM_RANGE_FINDER_H_


typedef struct _GdamRangeFinder GdamRangeFinder;
typedef struct _GdamRangeFinderClass GdamRangeFinderClass;

#include "gdammididevice.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_range_finder_get_type();
#define GDAM_TYPE_RANGE_FINDER			(gdam_range_finder_get_type ())
#define GDAM_RANGE_FINDER(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_RANGE_FINDER, GdamRangeFinder))
#define GDAM_RANGE_FINDER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_RANGE_FINDER, GdamRangeFinderClass))
#define GDAM_IS_RANGE_FINDER(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_RANGE_FINDER))
#define GDAM_IS_RANGE_FINDER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_RANGE_FINDER))

struct _GdamRangeFinderClass {
	GdamInputDeviceFileClass	midi_device_class;
};
struct _GdamRangeFinder {
	GdamInputDeviceFile		midi_device;

	/* Number parsing junk... */
	gboolean			in_number;
	int				cur_value;
	int				device_number;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
