#ifndef __GDAM_RECORDER_EXTERNAL_H_
#define __GDAM_RECORDER_EXTERNAL_H_


typedef struct _GdamRecorderExternal GdamRecorderExternal;
typedef struct _GdamRecorderExternalClass GdamRecorderExternalClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamfilter.h"

GtkType gdam_recorder_external_get_type();
#define GDAM_TYPE_RECORDER_EXTERNAL			(gdam_recorder_external_get_type ())
#define GDAM_RECORDER_EXTERNAL(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_RECORDER_EXTERNAL, GdamRecorderExternal))
#define GDAM_RECORDER_EXTERNAL_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_RECORDER_EXTERNAL, GdamRecorderExternalClass))
#define GDAM_IS_RECORDER_EXTERNAL(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_RECORDER_EXTERNAL))
#define GDAM_IS_RECORDER_EXTERNAL_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_RECORDER_EXTERNAL))

struct _GdamRecorderExternalClass {
	GdamFilterClass		filter_class;
};
struct _GdamRecorderExternal {
	GdamFilter			filter;
};

typedef void (*GdamRecorderHandleNewOutput)(int          output_id,
                                            void*        user_data);

void gdam_recorder_external_start_connect(GdamRecorderExternal*  external,
                                          const char*            spec,
					  GdamRecorderHandleNewOutput handler,
					  GHookFunc              on_failure,
					  gpointer               user_data);
void gdam_recorder_external_start_file   (GdamRecorderExternal*  external,
                                          const char*            filename,
					  gboolean               overwrite,
					  GdamRecorderHandleNewOutput handler,
					  GHookFunc              failure,
					  gpointer               user_data);
void gdam_recorder_external_stop         (GdamRecorderExternal*  external,
                                          int                    output_id);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
