/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SCRUB_H_
#define __GDAM_SCRUB_H_


typedef struct _GdamScrub GdamScrub;
typedef struct _GdamScrubClass GdamScrubClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamfilter.h"

GtkType gdam_scrub_get_type();
#define GDAM_TYPE_SCRUB			(gdam_scrub_get_type ())
#define GDAM_SCRUB(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SCRUB, GdamScrub))
#define GDAM_SCRUB_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SCRUB, GdamScrubClass))
#define GDAM_IS_SCRUB(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SCRUB))
#define GDAM_IS_SCRUB_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SCRUB))

struct _GdamScrubClass {
	GdamFilterClass		filter_class;
};
struct _GdamScrub {
	GdamFilter		filter;

	/* the amount to skip back when we've read to
	 * the end of the buffer, in seconds.
	 */
	gdouble			scrub_length;

	/* the rate to read in new data; must be in the range
	 *         0 <= input_rate <= 1.
	 */
	gdouble                 input_rate;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
