/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __COMPONENT_FILTER_SPIN_H_
#define __COMPONENT_FILTER_SPIN_H_

#include <gdam/component/gdamechobase.h>

GtkType gdam_spin_get_type();
#define GDAM_TYPE_SPIN			(gdam_spin_get_type ())
#define GDAM_SPIN(obj)			(GTK_CHECK_CAST ((obj), GDAM_TYPE_SPIN, GdamSpin))
#define GDAM_SPIN_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SPIN, GdamSpinClass))
#define GDAM_IS_SPIN(obj)		(GTK_CHECK_TYPE ((obj), GDAM_TYPE_SPIN)
#define GDAM_IS_SPIN_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SPIN)

typedef struct _GdamSpin GdamSpin;
typedef struct _GdamSpinClass GdamSpinClass;

struct _GdamSpinClass
{
	GdamEchoBaseClass	echo_base_class;
};

struct _GdamSpin 
{
	GdamEchoBase		echo_base;
	  /* We keep these gtk widgets around for convenience. */
	gboolean		spun;
	/* The length in beats of the spun sound.  Interpreted as length 
	 * in seconds if the bpm isn't known. 
	 */
	float			beat_factor;
	int 			set_source_connect_id;
};

GdamSpin*	gdam_spin_new		();
void		gdam_spin_free	(GdamSpin*		spin);

#endif
