/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_XMMS_FILTER_H_
#define __GDAM_XMMS_FILTER_H_


typedef struct _GdamXmmsFilter GdamXmmsFilter;
typedef struct _GdamXmmsFilterClass GdamXmmsFilterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamfilter.h"

GtkType gdam_xmms_filter_get_type();
#define GDAM_TYPE_XMMS_FILTER			(gdam_xmms_filter_get_type ())
#define GDAM_XMMS_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_XMMS_FILTER, GdamXmmsFilter))
#define GDAM_XMMS_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_XMMS_FILTER, GdamXmmsFilterClass))
#define GDAM_IS_XMMS_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_XMMS_FILTER))
#define GDAM_IS_XMMS_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_XMMS_FILTER))

struct _GdamXmmsFilterClass {
	GdamFilterClass		filter_class;

	void                  (*connected)(GdamXmmsFilter* filter);
	void                  (*didnt_connect)(GdamXmmsFilter* filter);
};
struct _GdamXmmsFilter {
	GdamFilter		filter;

	char*			path;
	unsigned		is_connected : 1;
	unsigned		is_connecting : 1;
};

void gdam_xmms_filter_connect(GdamXmmsFilter*    xmms,
                              const char*        path);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
