#include <gtk/gtk.h>
#include <stdio.h>


static gboolean print_value(gpointer adj)
{
  gfloat val = GTK_ADJUSTMENT (adj)->value;
  int channel;
  channel = GPOINTER_TO_INT (gtk_object_get_user_data (GTK_OBJECT (adj)));
  printf ("%d %d\n", channel, (int) val);
  fflush (stdout);
  return TRUE;
}

GtkWidget* make_scrollbar(int i)
{
  GtkWidget *scrollbar;
  GtkAdjustment *adjustment;
  adjustment = (GtkAdjustment *)
    gtk_adjustment_new (0.0, 0.0, 16387.0, 0.1, 0.1, 0.1);
  gtk_object_set_user_data (GTK_OBJECT (adjustment), GINT_TO_POINTER (i));
  scrollbar = gtk_vscrollbar_new (adjustment);
  g_timeout_add (50, print_value, adjustment);
  gtk_widget_show (scrollbar);
  return scrollbar;
}
	
int
main(int argc, char** argv)
{

  GtkWidget *window;
  GtkWidget *box;
  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  box = gtk_hbox_new (TRUE, 2);
  gtk_widget_show (box);
  gtk_box_pack_start_defaults (GTK_BOX (box), make_scrollbar (0));
  gtk_box_pack_start_defaults (GTK_BOX (box), make_scrollbar (1));
  gtk_box_pack_start_defaults (GTK_BOX (box), make_scrollbar (2));
  gtk_container_add (GTK_CONTAINER (window), box);
  gtk_widget_show (window);

  gtk_main ();
  return 0;
}
