/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_DEVICE_ALSA_H__
#define __GDAM_DEVICE_ALSA_H__

#include <gdam/server/gdamoutputdevice.h>

typedef struct _GdamDeviceAlsaClass GdamDeviceAlsaClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_device_alsa_get_type();
#define GDAM_TYPE_DEVICE_ALSA			(gdam_device_alsa_get_type ())
#define GDAM_DEVICE_ALSA(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_DEVICE_ALSA, GdamDeviceAlsa))
#define GDAM_DEVICE_ALSA_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_DEVICE_ALSA, GdamDeviceAlsaClass))
#define GDAM_IS_DEVICE_ALSA(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_DEVICE_ALSA))
#define GDAM_IS_DEVICE_ALSA_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_DEVICE_ALSA))

struct _GdamDeviceAlsaClass {
	GdamOutputDeviceClass		output_device_class;
};


GtkType gdam_device_alsa_get_type();
#define GDAM_TYPE_DEVICE_ALSA        (gdam_device_alsa_get_type ())
#define GDAM_DEVICE_ALSA(obj)        (GTK_CHECK_CAST ((obj), GDAM_TYPE_DEVICE_ALSA, GdamDeviceAlsa))


typedef struct _GdamDeviceAlsa GdamDeviceAlsa;

struct _GdamDeviceAlsa {
	GdamOutputDevice	sink;
	int			device_fd;
	GPollFD			poll_fd;
	guint			source_id;

	/* of type ``snd_ctl_t*'' */
	void*                   alsa_handle;
};

GdamSink* gdam_device_alsa_new (gpointer      device_data,
                               const char*   device_name,
			       const char*   device_options);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
