#include "gdamarctan.h"
#include <glib.h>
#include <math.h>

static int* arctan_values = NULL;

#define TABLE_LOG_SIZE 15
#define GRAN	       12
#define NBITS          23

#define TABLE_SIZE     (1 << TABLE_LOG_SIZE)

void gdam_arctan_init()
{
  int i;
  gdouble max_value;
  if (arctan_values != NULL)
    return;
  arctan_values = g_new (int, TABLE_SIZE);
  max_value = atan2 (TABLE_SIZE, (1 << (NBITS - GRAN)));
  for (i = 0; i < TABLE_SIZE; i++)
    {
      arctan_values[i] = (int) (atan2 (i, (1 << (NBITS - GRAN)))
				/ max_value * ((1 << NBITS) - 1));
    }
}

static inline int
arctan_positive(guint input)
{
  int index = (input >> GRAN);
  int fraction = (input % (1 << GRAN));
  int v1, v2;
  int r;
  gint64 rv;
  if (index >= TABLE_SIZE - 1)
    return arctan_values[TABLE_SIZE - 1];
  v1 = arctan_values[index];
  v2 = arctan_values[index + 1];
  rv = (gint64) v1 *((1 << GRAN) - fraction) + (gint64) v2 *fraction;
  r = (int) (rv >> GRAN);
  return r;
}
int gdam_arctan_b24(int input)
{
  return (input < 0) ? -arctan_positive (-input) : arctan_positive (input);
}
