/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdamauthenticator.h"

static void do_not_destroy(GdamAuthenticator* authenticator)
{
}

static GdamBuffer*
authenticate_root(GdamAuthenticator* auth,
                  GdamBuffer*        incoming,
		  GdamPermissions*   to_set,
		  gboolean*          done,
		  gboolean*          failed)
{
  GdamBuffer *response = gdam_buffer_new ();
  gdam_buffer_append_string (response, "ROOT");
  gdam_permissions_root (to_set);
  *done = TRUE;
  *failed = FALSE;
  return response;
}

static GdamBuffer*
authenticate_none(GdamAuthenticator* auth,
                  GdamBuffer*        incoming,
		  GdamPermissions*   to_set,
		  gboolean*          done,
		  gboolean*          failed)
{
  GdamBuffer *response = gdam_buffer_new ();
  gdam_buffer_append_string (response, "NONE");
  gdam_permissions_none (to_set);
  *done = TRUE;
  *failed = FALSE;
  return response;
}

static GdamAuthenticator the_root_auth = {
	authenticate_root,
	do_not_destroy
};
static GdamAuthenticator the_none_auth = {
	authenticate_none,
	do_not_destroy
};

GdamAuthenticator* gdam_authenticator_root()
{
  return &the_root_auth;
}
GdamAuthenticator* gdam_authenticator_none()
{
  return &the_none_auth;
}
