/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdampermissions.h"

/* Give the user no rights. */
void gdam_permissions_none(GdamPermissions*  to_clear)
{
  to_clear->may_create_source = 0;
  to_clear->may_open_device = 0;
  to_clear->may_affect_others = 0;
  to_clear->user_id = -1;
}

/* Give the user super-user rights. */
void gdam_permissions_root(GdamPermissions* to_set)
{
  to_set->may_create_source = 1;
  to_set->may_open_device = 1;
  to_set->may_affect_others = 1;
  to_set->user_id = 0;
}
