#ifndef __GDAMDSPPRELOAD_H_
#define __GDAMDSPPRELOAD_H_

enum {
	GDAMDSP_ID = 400,
	GDAMDSP_OPEN,	/* open the device; payload is devicename */
	GDAMDSP_IOCTL,
	GDAMDSP_WRITE,
	GDAMDSP_CLOSE
};

/* packet syntax:
 *
 *     packet type            payload syntax
 *     ===========            ==============
 *
 *     GDAMDSP_ID             the first packet.  contains an identifying
 *                            string the server can print for user convenience
 *
 *     GDAMDSP_OPEN           just the device name
 *
 *     GDAMDSP_IOCTL          string describing the ioctl that was transmitted:
 *                                  reset
 *                                      ...
 *                                  post
 *                                      ...
 *                                  setfmt [...]
 *                                      ...
 *     GDAMDSP_WRITE          raw data transmitted to device
 *                                 [should be interpretted according to setfmt
 *                                  and so on]
 *     GDAMDSP_CLOSE          no parameters [???]
 */

#endif
