/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_FADER_H_
#define __GDAS_FADER_H_


typedef struct _GdasFader GdasFader;
typedef struct _GdasFaderClass GdasFaderClass;

#include <gdam/server/gdasfilter.h>

typedef enum {
	GDAS_FADER_TERMINATES,
	GDAS_FADER_LOOPS,
	GDAS_FADER_SHELF
} GdasFaderMode;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdas_fader_get_type();
#define GDAS_TYPE_FADER			(gdas_fader_get_type ())
#define GDAS_FADER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_FADER, GdasFader))
#define GDAS_FADER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_FADER, GdasFaderClass))
#define GDAM_IS_FADER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_FADER))
#define GDAM_IS_FADER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_FADER))

struct _GdasFaderClass {
	GdasFilterClass		fader_class;
};
struct _GdasFader {
	GdasFilter			fader;

	gint64				position;
	int				terminates;
	int				num_time_vols;
	gint64*				time_vols;
	GdasFaderMode			mode;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
