/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_FEEDBACK_FILTER_H_
#define __GDAS_FEEDBACK_FILTER_H_


typedef struct _GdasFeedbackFilter GdasFeedbackFilter;
typedef struct _GdasFeedbackFilterClass GdasFeedbackFilterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"

GtkType gdas_feedback_filter_get_type();
#define GDAS_TYPE_FEEDBACK_FILTER			(gdas_feedback_filter_get_type ())
#define GDAS_FEEDBACK_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_FEEDBACK_FILTER, GdasFeedbackFilter))
#define GDAS_FEEDBACK_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_FEEDBACK_FILTER, GdasFeedbackFilterClass))
#define GDAM_IS_FEEDBACK_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_FEEDBACK_FILTER))
#define GDAM_IS_FEEDBACK_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_FEEDBACK_FILTER))

struct _GdasFeedbackFilterClass {
	GdasFilterClass		filter_class;
};
struct _GdasFeedbackFilter {
	GdasFilter		filter;

	GdasFeedbackFilter*	feed_into;
	guint			feed_into_destroy_id;

	GdamSample*		buffer;
	int			buffer_alloc;
	int			buffer_amount;	/* samples buffered */
	int			buffer_start;	/* first index to read from
	                                         * feed_buffer. */
	GdamFixed		feedback_volume;
	GdamFixed		input_volume;

	int			delay;
};

void   gdas_feedback_filter_set_dest(GdasFeedbackFilter* later_in_chain,
                                     GdasFeedbackFilter* earlier_in_chain);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
