/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_GONG_H_
#define __GDAS_GONG_H_


typedef struct _GdasGong GdasGong;
typedef struct _GdasGongClass GdasGongClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdassource.h"

GtkType gdas_gong_get_type();
#define GDAS_TYPE_GONG			(gdas_gong_get_type ())
#define GDAS_GONG(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_GONG, GdasGong))
#define GDAS_GONG_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_GONG, GdasGongClass))
#define GDAM_IS_GONG(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_GONG))
#define GDAM_IS_GONG_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_GONG))

struct _GdasGongClass {
	GdasSourceClass		source_class;
};
struct _GdasGong {
	GdasSource		source;

	GSList*			gongs;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
