/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_IIR_FILTER_H_
#define __GDAS_IIR_FILTER_H_


typedef struct _GdasIirFilter GdasIirFilter;
typedef struct _GdasIirFilterClass GdasIirFilterClass;
typedef struct _GdamIirPole GdamIirPole;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"

GtkType gdas_iir_filter_get_type();
#define GDAS_TYPE_IIR_FILTER			(gdas_iir_filter_get_type ())
#define GDAS_IIR_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_IIR_FILTER, GdasIirFilter))
#define GDAS_IIR_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_IIR_FILTER, GdasIirFilterClass))
#define GDAM_IS_IIR_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_IIR_FILTER))
#define GDAM_IS_IIR_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_IIR_FILTER))

struct _GdasIirFilterClass {
	GdasFilterClass		filter_class;
};

struct _GdamIirPole {
	int			delay;
	GdamFixed		fir;
	GdamFixed		iir;
};

struct _GdasIirFilter {
	GdasFilter		filter;

	int			num_poles;
	GdamIirPole*		poles;

	GdamSample*		input;
	GdamSample*		output;
	int			length;

	/* Next index to fill. */
	int			next_index;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
