/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_LIMITER_H_
#define __GDAS_LIMITER_H_


typedef struct _GdasLimiter GdasLimiter;
typedef struct _GdasLimiterClass GdasLimiterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "gdasdynamicrange.h"

GtkType gdas_limiter_get_type();
#define GDAS_TYPE_LIMITER			(gdas_limiter_get_type ())
#define GDAS_LIMITER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_LIMITER, GdasLimiter))
#define GDAS_LIMITER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_LIMITER, GdasLimiterClass))
#define GDAM_IS_LIMITER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_LIMITER))
#define GDAM_IS_LIMITER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_LIMITER))

struct _GdasLimiterClass {
	GdasDynamicRangeClass	dynamic_range_class;
};
struct _GdasLimiter {
	GdasDynamicRange	dynamic_range;

	GdamSampleValue		threshold;

	/* Pass only quiet noise through. */
	gboolean		inverted;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
