/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_MOOG_H_
#define __GDAS_MOOG_H_


typedef struct _GdasMoog GdasMoog;
typedef struct _GdasMoogClass GdasMoogClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"

GtkType gdas_moog_get_type();
#define GDAS_TYPE_MOOG			(gdas_moog_get_type ())
#define GDAS_MOOG(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_MOOG, GdasMoog))
#define GDAS_MOOG_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_MOOG, GdasMoogClass))
#define GDAM_IS_MOOG(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_MOOG))
#define GDAM_IS_MOOG_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_MOOG))

struct _GdasMoogClass {
	GdasFilterClass		filter_class;

};
struct _GdasMoog {
	GdasFilter		filter;

	GdamSample		in[4];
	GdamSample		out[4];
	
	GdamFixed		frequency;
	GdamFixed		resonance;

	GdamFixed		fb, f;
	GdamFixed		input_scale;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
