/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_OCTAVE_DOWN_H_
#define __GDAS_OCTAVE_DOWN_H_


typedef struct _GdasOctaveDown GdasOctaveDown;
typedef struct _GdasOctaveDownClass GdasOctaveDownClass;

#include "../gdasfilter.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdas_octave_down_get_type();
#define GDAS_TYPE_OCTAVE_DOWN			(gdas_octave_down_get_type ())
#define GDAS_OCTAVE_DOWN(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_OCTAVE_DOWN, GdasOctaveDown))
#define GDAS_OCTAVE_DOWN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_OCTAVE_DOWN, GdasOctaveDownClass))
#define GDAM_IS_OCTAVE_DOWN(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_OCTAVE_DOWN))
#define GDAM_IS_OCTAVE_DOWN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_OCTAVE_DOWN))

struct _GdasOctaveDownClass {
	GdasFilterClass		filter_class;
};
struct _GdasOctaveDown {
	GdasFilter			filter;
	unsigned			last_l_neg : 1,
					last_r_neg : 1,
					invert_l : 1,
				 	invert_r : 1;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
