/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_PITCH_SHIFT_H_
#define __GDAS_PITCH_SHIFT_H_

typedef struct _GdasPitchShift GdasPitchShift;
typedef struct _GdasPitchShiftClass GdasPitchShiftClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"

GtkType gdas_pitch_shift_get_type();
#define GDAS_TYPE_PITCH_SHIFT			(gdas_pitch_shift_get_type ())
#define GDAS_PITCH_SHIFT(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_PITCH_SHIFT, GdasPitchShift))
#define GDAS_PITCH_SHIFT_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_PITCH_SHIFT, GdasPitchShiftClass))
#define GDAS_IS_PITCH_SHIFT(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_PITCH_SHIFT))
#define GDAS_IS_PITCH_SHIFT_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_PITCH_SHIFT))

struct _GdasPitchShiftClass {
	GdasFilterClass		filter_class;
};
struct _GdasPitchShift {
	GdasFilter		filter;

	int			delay_whole_incr;
	guint32			delay_frac_incr;

	int			start_delay;
	int			overlap_delta_delay;

	int			delay_0;
	guint32			delay_0_frac;

	int			delay_1;
	guint32			delay_1_frac;

	GdamSample*		buffer;
	int			insert_index;
	int			buffer_length;
	int			cur_buffer_length;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
