/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_QUEUE_H_
#define __GDAS_QUEUE_H_


/*
 * A source which is the continuous concatenation of
 * several sources.
 */

typedef struct _GdasQueue GdasQueue;
typedef struct _GdasQueueClass GdasQueueClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdassource.h"

GtkType gdas_queue_get_type();
#define GDAS_TYPE_QUEUE			(gdas_queue_get_type ())
#define GDAS_QUEUE(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_QUEUE, GdasQueue))
#define GDAS_QUEUE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_QUEUE, GdasQueueClass))
#define GDAM_IS_QUEUE(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_QUEUE))
#define GDAM_IS_QUEUE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_QUEUE))

struct _GdasQueueClass {
	GdasSourceClass		source_class;
};
struct _GdasQueue {
	GdasSource		source;

	GSList*			first_source;
	GSList*			last_source;

	gboolean		terminates;
};

GdasQueue* gdas_queue_new      ();
void       gdas_queue_enqueue  (GdasQueue*    queue,
                                GdasSource*   source);
void       gdas_queue_dequeue  (GdasQueue*    queue);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
