#ifndef __GDAS_SECOND_ORDER_FILTER_H_
#define __GDAS_SECOND_ORDER_FILTER_H_


typedef struct _GdasSecondOrderFilter GdasSecondOrderFilter;
typedef struct _GdasSecondOrderFilterClass GdasSecondOrderFilterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"

GtkType gdas_second_order_filter_get_type();
#define GDAS_TYPE_SECOND_ORDER_FILTER			(gdas_second_order_filter_get_type ())
#define GDAS_SECOND_ORDER_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_SECOND_ORDER_FILTER, GdasSecondOrderFilter))
#define GDAS_SECOND_ORDER_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_SECOND_ORDER_FILTER, GdasSecondOrderFilterClass))
#define GDAM_IS_SECOND_ORDER_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_SECOND_ORDER_FILTER))
#define GDAM_IS_SECOND_ORDER_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_SECOND_ORDER_FILTER))

struct _GdasSecondOrderFilterClass {
	GdasFilterClass		filter_class;
};

struct _GdasSecondOrderFilter {
	GdasFilter		filter;

	int			max_length;

	int       		in_first_order_length;
	GdamFixed*		in_first_order;
	int       		in_second_order_length;
	GdamFixed*		in_second_order;

	int       		out_first_order_length;
	GdamFixed*		out_first_order;
	int       		out_second_order_length;
	GdamFixed*		out_second_order;

	GdamSample*		past_in;
	GdamSample*		past_out;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
