/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_SPLINE_MAP_H_
#define __GDAS_SPLINE_MAP_H_


typedef struct _GdasSplineMap GdasSplineMap;
typedef struct _GdasSplineMapClass GdasSplineMapClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"

GtkType gdas_spline_map_get_type();
#define GDAS_TYPE_SPLINE_MAP			(gdas_spline_map_get_type ())
#define GDAS_SPLINE_MAP(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_SPLINE_MAP, GdasSplineMap))
#define GDAS_SPLINE_MAP_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_SPLINE_MAP, GdasSplineMapClass))
#define GDAS_IS_SPLINE_MAP(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_SPLINE_MAP))
#define GDAS_IS_SPLINE_MAP_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_SPLINE_MAP))

struct _GdasSplineMapClass {
	GdasFilterClass		filter_class;
};
struct _GdasSplineMap {
	GdasFilter	filter;

	gint num_points;
	gdouble *x;
	gdouble *y;
	gdouble *y2;
};

GdasSplineMap*   gdas_spline_map_new();

void    gdas_spline_map_set_points(GdasSplineMap*   spline,
                                   int              num_points,
                                   const gdouble*   x,
                                   const gdouble*   y,
                                   const gdouble*   dx,
                                   const gdouble*   dy);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
