/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_VIBRATO_H_
#define __GDAS_VIBRATO_H_


typedef struct _GdasVibrato GdasVibrato;
typedef struct _GdasVibratoClass GdasVibratoClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <gdam/server/gdasfilter.h>

GtkType gdas_vibrato_get_type();
#define GDAS_TYPE_VIBRATO			(gdas_vibrato_get_type ())
#define GDAS_VIBRATO(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_VIBRATO, GdasVibrato))
#define GDAS_VIBRATO_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_VIBRATO, GdasVibratoClass))
#define GDAM_IS_VIBRATO(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_VIBRATO))
#define GDAM_IS_VIBRATO_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_VIBRATO))

struct _GdasVibratoClass {
	GdasFilterClass			filter_class;
};
struct _GdasVibrato {
	GdasFilter			filter;

	GdamBuffer			filtered_buffer;
	GdamBuffer			vibrato_buffer;
	GdasSource*			vibrato;

	gint64  			frac_b32;
	GdamSample			last_sample;

	GdamFixed			min_traverse;
	GdamFixed			max_traverse;
};

void gdas_vibrato_set_vibrato(GdasVibrato* vibrato, GdasSource* sub);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
