/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/

#ifndef __GDAS_VOLUME_METER_H_
#define __GDAS_VOLUME_METER_H_

typedef struct _GdasVolumeMeter GdasVolumeMeter;
typedef struct _GdasVolumeMeterClass GdasVolumeMeterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasbufferingfilter.h"

GtkType gdas_volume_meter_get_type();
#define GDAS_TYPE_VOLUME_METER			(gdas_volume_meter_get_type ())
#define GDAS_VOLUME_METER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_VOLUME_METER, GdasVolumeMeter))
#define GDAS_VOLUME_METER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_VOLUME_METER, GdasVolumeMeterClass))
#define GDAM_IS_VOLUME_METER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_VOLUME_METER))
#define GDAM_IS_VOLUME_METER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_VOLUME_METER))

struct _GdasVolumeMeterClass {
	GdasBufferingFilterClass	buffering_filter_class;
};
struct _GdasVolumeMeter {
	GdasBufferingFilter		buffering_filter;

	int				window;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
