/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_XMMS_VIS_FILTER_H_
#define __GDAS_XMMS_VIS_FILTER_H_


typedef struct _GdasXmmsVisFilter GdasXmmsVisFilter;
typedef struct _GdasXmmsVisFilterClass GdasXmmsVisFilterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"

GtkType gdas_xmms_vis_filter_get_type();
#define GDAS_TYPE_XMMS_VIS_FILTER			(gdas_xmms_vis_filter_get_type ())
#define GDAS_XMMS_VIS_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_XMMS_VIS_FILTER, GdasXmmsVisFilter))
#define GDAS_XMMS_VIS_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_XMMS_VIS_FILTER, GdasXmmsVisFilterClass))
#define GDAS_IS_XMMS_VIS_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_XMMS_VIS_FILTER))
#define GDAS_IS_XMMS_VIS_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_XMMS_VIS_FILTER))

struct _GdasXmmsVisFilterClass {
	GdasFilterClass		filter_class;
};
struct _GdasXmmsVisFilter {
	GdasFilter		filter;

	GdamSample*		lr_analysis_buffer;
	gint16*			analysis_buffer;
	int			cur_amount;
	int			analysis_length;

	int			fd;
	GPollFD			poll_fd;
	guint			source_id;
	gboolean		is_connecting;
	GdamBuffer		outgoing_buffer;
};

gboolean gdas_xmms_vis_filter_connect_unix(GdasXmmsVisFilter*   filter,
                                           const char*          unix_path);
gboolean gdas_xmms_vis_filter_connect_tcp (GdasXmmsVisFilter*   filter,
                                           const char*          hostname,
					   int                  port_num);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
