#! /usr/bin/perl -w

for $fname (@ARGV)
{
  open C, "<$fname" or die "couldn't open $fname.c";
  my $blurb; my $syntax;
  while (<C>) {
    if (/^\/\*\s+SYNTAX:\s+\((\S+)\s*(.*)\)\s+\*\/\s*$/)
      {
	$command = $1;
	$params = $2;
      }
    elsif (/^\/\*\s+BLURB:\s*$/)
      {
	$blurb = '';
	while (<C>)
	  {
	    last if (/\*\//);
	    s/^\s\*\s?//;
	    $blurb .= $_;
	  }
      }
  }
  if (!defined $command)
    {
      warn "need syntax blob in $fname";
      next;
    }
  $blurb = '' if (!defined $blurb);
  $blurb =~ s/(["\\])/\\$1/g;
  chomp $blurb;
  $blurb = "\"$blurb\"";
  print "($command ($params) $blurb)\n";
}

  
