/* SYNTAX: (modulate (stream-array modulated)) */
/* BLURB:
 * Multiply all the inputs from MODULATED together, ending when
 * the first one ends.
 */

#include "synthlib.h"

int main (int argc, char **argv)
{
  guint num_sources;
  SynthLibStream **sources;
  synth_lib_init (argc, argv);
  synth_lib_get_stream_array (&num_sources, &sources);
  if (num_sources == 0)
    return 0;
  for (;;)
    {
      gdouble v;
      guint i;
      if (!synth_lib_stream_get (sources[0], &v))
	return 0;
      for (i = 1; i < num_sources; i++)
	{
	  gdouble d;
	  if (!synth_lib_stream_get (sources[i], &d))
	    return 0;
	  v *= d;
	}
      synth_lib_output (v);
    }
  return 0;
}
