/* SYNTAX: (sine (double frequency)) */
/* BLURB:
 * Create an infinite sine-wave of the specified frequency.
 */

#include "synthlib.h"
#include <math.h>

int main (int argc, char **argv)
{
  gdouble at = 0;
  gdouble hertz;
  gdouble delta;
  SynthLibStream *source;
  synth_lib_init (argc, argv);
  synth_lib_get_double (&hertz);
  delta = hertz / synth_lib_sampling_rate * M_PI * 2.0;
  delta = fmod (delta, M_PI * 2.0);
  if (delta < 0.0)
    delta += M_PI * 2.0;
  for (;;)
    {
      synth_lib_output (sin (at));
      at += delta;
      if (at >= M_PI * 2.0)
	at -= M_PI * 2.0;
    }
  return 0;
}
