#ifndef __SYNTH_LIB__gdam_H_
#define __SYNTH_LIB__gdam_H_

typedef struct _SynthLibStream SynthLibStream;

#include <glib.h>

extern gdouble synth_lib_sampling_rate;

void synth_lib_init        (int argc,
                            char **argv);

void synth_lib_get_double        (gdouble     *val_out);
void synth_lib_get_int           (gint        *val_out);
void synth_lib_get_double_array  (guint       *len_out,
                                  gdouble    **val_out);
void synth_lib_get_string_array  (guint       *len_out,
                                  gchar     ***val_out);
void synth_lib_get_stream        (SynthLibStream **stream_out);
void synth_lib_get_stream_array  (guint       *len_out,
                                  SynthLibStream ***stream_out);
void synth_lib_output            (gdouble      sample);

SynthLibStream *synth_lib_stream_new   ();
void            synth_lib_stream_close (SynthLibStream *stream);
gboolean        synth_lib_stream_get   (SynthLibStream *stream,
                                        gdouble        *out);

void            synth_lib_error  (const char *format,
				  ...);

void synth_lib_flush_output ();

#endif
