#include <gdam/server/gdamcachebuffer.h>
#include <gdam/server/gdammain.h>

int main(int argc, char** argv)
{
  GdamCacheBuffer *buffer;
  GdamSample *sample_buffer;
  GdamSample *sample_buffer_out;
  GdamSample16 *sample16_buffer;
  GdamSample sample;
  int i;
  int rv;
  int end_index;
  guint32 end_index_frac;

  sample_buffer = g_new (GdamSample, 128);

  gdam_init (NULL, NULL);

  for (i = 0; i < 128; i++)
    {
      sample_buffer[i].s[0] = (gint64) (GDAM_SAMPLE_ONE - 1) * i / 127;
      sample_buffer[i].s[1] = (-sample_buffer[i].s[0]);
    }
  buffer = gdam_cache_buffer_memory (128, sample_buffer, g_free, FALSE);
  sample = gdam_cache_buffer_index (buffer, 0);
  g_assert (sample.s[0] == 0);
  g_assert (sample.s[1] == -sample.s[1]);
  sample = gdam_cache_buffer_index (buffer, 127);
  g_assert (sample.s[0] == GDAM_SAMPLE_ONE - 1);
  g_assert (sample.s[1] == - GDAM_SAMPLE_ONE + 1);

  sample_buffer_out = g_new (GdamSample, 128);
  rv = gdam_cache_buffer_read (buffer, sample_buffer_out, 0, 0,
                               &end_index, &end_index_frac, 128,
			       GdamFixed_ONE, GdamFixed_ONE, FALSE);
  g_assert (rv == 128);
  g_assert (memcmp (sample_buffer_out,
                    sample_buffer,
		    rv * sizeof (GdamSample)) == 0);
  g_assert (end_index == 128);
  g_assert (end_index_frac == 0);
  return 0;
}
