#ifndef __TEST_RESULT_H_
#define __TEST_RESULT_H_

typedef struct _TestResult TestResult;

#include "../gdassource.h"

struct _TestResult {
  gint64 num_samples_compared;
  gdouble squared_deviations;		/* deviations are normalized
                                         * GDAM_SAMPLE_ONE => 1.0 */
  gdouble max_deviation;
  /* num_sample_from_1 - num_sample_from_0 */
  int num_delta;

  gboolean is_finished;
};

TestResult *test_result_new                ();
void        test_result_process            (TestResult   *result,
                                            int           num_samples,
                                            GdamSample   *samples_0,
					    GdamSample   *samples_1);
void        test_result_process_overflow   (TestResult   *result,
                                            int           num_samples,
                                            GdamSample   *samples,
					    int           which_source);
void        test_result_finish             (TestResult   *result);
void        test_result_destroy            (TestResult   *test_result);

TestResult *test_result_compare_sources    (GdasSource   *source_0,
                                            GdasSource   *source_1);
gboolean    test_result_is_with_thresholds (TestResult   *result, 
                                            const char   *threshold);


#endif
