#! /bin/sh

test -s src/play.xpm || {
	#echo "Cannot build pixmaps; should be included anyway."
	exit 0
}

for MODE in normal prelight active ; do

	case $MODE in
		normal)
			COLOR=303030
			;;
		prelight)
			COLOR=803040
			;;
		active)
			COLOR=B03040
			;;
	esac

	echo "mode $MODE; color $COLOR"

	cp $srcdir/src/play.xpm play_$MODE.xpm
	cp $srcdir/src/stop.xpm stop_$MODE.xpm
	cp $srcdir/src/start.xpm start_$MODE.xpm
	cp $srcdir/src/hardware.xpm hardware_$MODE.xpm
	cp $srcdir/src/nudgeb.xpm nudgeb_$MODE.xpm
	cp $srcdir/src/nudgef.xpm nudgef_$MODE.xpm
	cp $srcdir/src/nudgemf.xpm nudgemf_$MODE.xpm
	cp $srcdir/src/nudgeff.xpm nudgeff_$MODE.xpm
	cp $srcdir/src/nudgemff.xpm nudgemff_$MODE.xpm

	for IMAGE in nudgeb nudgef 		\
	             nudgeff		\
		     nudgemf		\
		     nudgemff		\
		     play start stop	\
		     hardware; do
		perl -p -i -e 's/\#FFFFFF/None/; s/\#000000/\#'$COLOR'/' ${IMAGE}_$MODE.xpm
	done

	cp $srcdir/nudgemf_$MODE.xpm nudgemb_$MODE.xpm
	cp $srcdir/nudgemff_$MODE.xpm nudgembb_$MODE.xpm
	cp $srcdir/nudgeff_$MODE.xpm nudgebb_$MODE.xpm

	for IMAGE in nudgemb nudgembb nudgebb ; do
		mogrify -flop ${IMAGE}_$MODE.xpm
	done

done

for a in *_normal.xpm ; do
	mv $a `echo $a | sed -e 's/_normal//'`
done
