#include <gtk/gtkitemfactory.h>
#include <gtk/gtkmenu.h>
#include "xmmsvisutil.h"


/*  The following was cut and paste from the xmms source code as a
 *  temporary measure while adding xmm plugin support.  */

/******  BEGIN CUT AND PASTE  *****/

/*
 * util_item_factory_popup() is a dropin replacement for gtk_item_factory_popup().
 * The difference is that the menu is always poped up whithin the screen.
 * Note that this means it does not neccesarily pop up at (x,y).
 */

void util_item_factory_popup(GtkItemFactory * ifactory, guint x, guint y, guint mouse_button, guint32 time)
{
        static GQuark quark_user_menu_pos = 0;
        struct Pos
        {
                gint x;
                gint y;
        }
           *pos;

        if (!quark_user_menu_pos)
                quark_user_menu_pos = g_quark_from_static_string("user_menu_pos");

        pos = gtk_object_get_data_by_id(GTK_OBJECT(ifactory), quark_user_menu_pos);
        if (!pos)
        {
                pos = g_malloc0(sizeof (struct Pos));

                gtk_object_set_data_by_id_full(GTK_OBJECT(ifactory->widget), quark_user_menu_pos, pos, g_free);
        }
        pos->x = x;
        pos->y = y;

        gtk_menu_popup(GTK_MENU(ifactory->widget), NULL, NULL, NULL, pos, mouse_button, time);
}

/******  END CUT AND PASTE  *****/

