/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdamkeyboardtrap.h"
#include <gtk/gtksignal.h>

typedef enum {
	PRESS,
	RELEASE,
	LAST_SIGNAL
} GdamComponentSignals;
static guint keyboard_signals[LAST_SIGNAL] = {0};


static void gdam_keyboard_trap_init(GdamKeyboardTrap* keyboard_trap)
{
}

static void gdam_keyboard_trap_class_init(GtkObjectClass* object_class)
{
  keyboard_signals[PRESS] =
    gtk_signal_new ("pressed",
		    GTK_RUN_LAST | GTK_RUN_NO_HOOKS,
		    object_class->type,
		    GTK_SIGNAL_OFFSET (GdamKeyboardTrapClass,
				       pressed),
		    gtk_marshal_NONE__NONE, GTK_TYPE_NONE, 0);

  keyboard_signals[RELEASE] =
    gtk_signal_new ("released",
		    GTK_RUN_LAST | GTK_RUN_NO_HOOKS,
		    object_class->type,
		    GTK_SIGNAL_OFFSET (GdamKeyboardTrapClass,
				       released),
		    gtk_marshal_NONE__NONE, GTK_TYPE_NONE, 0);
  gtk_object_class_add_signals (object_class, keyboard_signals, LAST_SIGNAL);
}

GtkType gdam_keyboard_trap_get_type()
{
  static GtkType keyboard_trap_type = 0;
  if (!keyboard_trap_type)
    {
      static const GtkTypeInfo keyboard_trap_info = {
	"GdamKeyboardTrap",
	sizeof (GdamKeyboardTrap),
	sizeof (GdamKeyboardTrapClass),
	(GtkClassInitFunc) gdam_keyboard_trap_class_init,
	(GtkObjectInitFunc) gdam_keyboard_trap_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      GtkType parent = GTK_TYPE_OBJECT;
      keyboard_trap_type = gtk_type_unique (parent, &keyboard_trap_info);
    }
  return keyboard_trap_type;
}
