/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdamresampleskin.h"
#include <gdam/component/gdamresample.h>
#include <stdlib.h>

static void gdam_resample_skin_class_init(GdamResampleSkinClass* klass);

/*    ____ _                 ____  _          __  __ 
 *   / ___| | __ _ ___ ___  / ___|| |_ _   _ / _|/ _|
 *  | |   | |/ _` / __/ __| \___ \| __| | | | |_| |_ 
 *  | |___| | (_| \__ \__ \  ___) | |_| |_| |  _|  _|
 *   \____|_|\__,_|___/___/ |____/ \__|\__,_|_| |_|  
 */                                                 

static void gdam_resample_skin_init(GdamResampleSkin* skin)
{
}

GtkType gdam_resample_skin_get_type()
{
  static GtkType resample_skin_type = 0;
  if (!resample_skin_type)
    {
      static const GtkTypeInfo resample_skin_info = {
	"GdamResampleSkin",
	sizeof (GdamResampleSkin),
	sizeof (GdamResampleSkinClass),
	(GtkClassInitFunc) gdam_resample_skin_class_init,
	(GtkObjectInitFunc) gdam_resample_skin_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      resample_skin_type = gtk_type_unique (GDAM_TYPE_SKIN,
					    &resample_skin_info);
    }
  return resample_skin_type;
}

static void gdam_resample_skin_class_init(GdamResampleSkinClass* klass)
{
  GdamSkinClass *skin_class = GDAM_SKIN_CLASS (klass);
  skin_class->model_type = GDAM_TYPE_RESAMPLE;
}
