/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAMBENDER_SKIN__H_
#define __GDAMBENDER_SKIN__H_

#include "../gdamskin.h"
#include <gdam/component/plugins/gdambender.h>


typedef struct _GdamBenderSkinClass GdamBenderSkinClass;
typedef struct _GdamBenderSkin GdamBenderSkin;


GtkType gdam_bender_skin_get_type();
#define GDAM_TYPE_BENDER_SKIN              (gdam_bender_skin_get_type ())
#define GDAM_BENDER_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_BENDER_SKIN, GdamBenderSkin))
#define GDAM_BENDER_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_BENDER_SKIN, GdamBenderSkinClass))
#define GDAM_IS_BENDER_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_BENDER_SKIN))
#define GDAM_IS_BENDER_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_BENDER_SKIN))

struct _GdamBenderSkinClass {
	GdamSkinClass		skin_class;
};


struct _GdamBenderSkin {
	GdamSkin		base;
	GtkContainer*           child_container;
	GdamSkin*		child_skin;
	gboolean		user_bending;
	GtkAdjustment*		bend_adj;
	GTimeVal 		bend_adj_time;
	GDAM_BENDER_MODE	bend_mode;
	float			last_rate;
	int			midi_channel;
	int			midi_mode;
};

static gdouble gdam_just_ratios_numeric[12] = 
    {1.0416666, 1.0546875, 1.066666, 1.111111,
     1.125,     1.2,       1.25,     1.333333,
     1.5,       1.6666666, 1.875,    2.0};

static gdouble gdam_just_ratios_consonant[12] = 
    {2.0,       1.5,       1.333333, 1.666666,
     1.25,      1.2,       1.125,    1.111111,
     1.875,     1.0666666, 1.0546875,1.0416666};

static gdouble gdam_pythagorean_ratios_consonant[10] = 
    {2.0,       1.5,       1.333333, 1.6875,  
     1.265625,  1.185185,  1.125,    1.8984375,
     1.05349792,1.067871};

#endif
