/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_FILTER_VIBRATO_SKIN_H_
#define __GDAM_FILTER_VIBRATO_SKIN_H_


typedef struct _GdamFilterVibratoSkin GdamFilterVibratoSkin;
typedef struct _GdamFilterVibratoSkinClass GdamFilterVibratoSkinClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "gdamfilterwavetableskin.h"

GtkType gdam_filter_vibrato_skin_get_type();
#define GDAM_TYPE_FILTER_VIBRATO_SKIN			(gdam_filter_vibrato_skin_get_type ())
#define GDAM_FILTER_VIBRATO_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_FILTER_VIBRATO_SKIN, GdamFilterVibratoSkin))
#define GDAM_FILTER_VIBRATO_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_FILTER_VIBRATO_SKIN, GdamFilterVibratoSkinClass))
#define GDAM_IS_FILTER_VIBRATO_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_FILTER_VIBRATO_SKIN))
#define GDAM_IS_FILTER_VIBRATO_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_FILTER_VIBRATO_SKIN))

struct _GdamFilterVibratoSkinClass {
	GdamFilterWavetableSkinClass		filter_wavetable_skin_class;
};
struct _GdamFilterVibratoSkin {
	GdamFilterWavetableSkin			filter_wavetable_skin;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
