#ifndef __GDAM_FIR_FILTER_SKIN_H_
#define __GDAM_FIR_FILTER_SKIN_H_


typedef struct _GdamFirFilterSkin GdamFirFilterSkin;
typedef struct _GdamFirFilterSkinClass GdamFirFilterSkinClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamskin.h"

GtkType gdam_fir_filter_skin_get_type();
#define GDAM_TYPE_FIR_FILTER_SKIN			(gdam_fir_filter_skin_get_type ())
#define GDAM_FIR_FILTER_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_FIR_FILTER_SKIN, GdamFirFilterSkin))
#define GDAM_FIR_FILTER_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_FIR_FILTER_SKIN, GdamFirFilterSkinClass))
#define GDAM_IS_FIR_FILTER_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_FIR_FILTER_SKIN))
#define GDAM_IS_FIR_FILTER_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_FIR_FILTER_SKIN))

struct _GdamFirFilterSkinClass {
	GdamSkinClass		skin_class;
};

struct _GdamFirFilterSkin {
	GdamSkin		skin;

	int			circle_radius;
	GdkGC*			circle_gc;
	GdkGC*			line_gc;
	GdkGC*			background;
	GdkPixmap*		backing_pixmap;

	gdouble			minimum_gain, maximum_gain;

	GtkWidget*		drawing_area;
	gdouble			area_length_in_grid;
	int			draw_width, draw_height;

	/* For when a circle is being dragged around. */
	int			which_dragging;
	int			drag_click_offset_x;
	int			drag_click_offset_y;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
