/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAMPRODUCERMP3CACHEABLESKIN__H_
#define __GDAMPRODUCERMP3CACHEABLESKIN__H_

#include "../gdamskin.h"
#include "../gdamproducermp3skin.h"
#include "../../component/plugins/gdamproducermp3cacheable.h"


typedef struct _GdamProducerMp3CacheableSkinClass GdamProducerMp3CacheableSkinClass;
typedef struct _GdamProducerMp3CacheableSkin GdamProducerMp3CacheableSkin;


GtkType gdam_producer_mp3_cacheable_skin_get_type();
#define GDAM_TYPE_PRODUCERMP3CACHEABLESKIN              (gdam_producer_mp3_cacheable_skin_get_type ())
#define GDAM_PRODUCERMP3CACHEABLESKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_PRODUCERMP3CACHEABLESKIN, GdamProducerMp3CacheableSkin))
#define GDAM_PRODUCERMP3CACHEABLESKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PRODUCERMP3CACHEABLESKIN, GdamProducerMp3CacheableSkinClass))
#define GDAM_IS_PRODUCERMP3CACHEABLESKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_PRODUCERMP3CACHEABLESKIN))
#define GDAM_IS_PRODUCERMP3CACHEABLESKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PRODUCERMP3CACHEABLESKIN))

struct _GdamProducerMp3CacheableSkinClass {
	GdamProducerMp3SkinClass		skin_class;
};


struct _GdamProducerMp3CacheableSkin {
	GdamProducerMp3Skin		base;
};

void gdam_producer_mp3_cacheable_connect_func(const gchar*   handler,
                                    	      GtkObject*     object,
                                    	      const gchar*   signal_name,
                                    	      const gchar*   signal_data,
                                    	      GtkObject*     connect_object,
                                    	      gboolean       after, 
                                    	      gpointer 	  data);


#endif
