/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/

#include "gdamscrubskin.h"
#include "../../component/plugins/gdamscrub.h"

static void gdam_scrub_skin_init(GdamScrubSkin* scrub_skin)
{
}
static void gdam_scrub_skin_class_init(GdamScrubSkinClass* scrub_skin_class)
{
  GdamSkinClass *skin_class;
  skin_class = GDAM_SKIN_CLASS (scrub_skin_class);
  skin_class->model_type = GDAM_TYPE_SCRUB;
}

GtkType gdam_scrub_skin_get_type()
{
  static GtkType scrub_skin_type = 0;
  if (!scrub_skin_type)
    {
      static const GtkTypeInfo scrub_skin_info = {
	"GdamScrubSkin",
	sizeof (GdamScrubSkin),
	sizeof (GdamScrubSkinClass),
	(GtkClassInitFunc) gdam_scrub_skin_class_init,
	(GtkObjectInitFunc) gdam_scrub_skin_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      GtkType parent = GDAM_TYPE_SKIN;
      scrub_skin_type = gtk_type_unique (parent, &scrub_skin_info);
    }
  return scrub_skin_type;
}
