/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SPATIAL_STEREO_SKIN_H_
#define __GDAM_SPATIAL_STEREO_SKIN_H_


typedef struct _GdamSpatialStereoSkin GdamSpatialStereoSkin;
typedef struct _GdamSpatialStereoSkinClass GdamSpatialStereoSkinClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_spatial_stereo_skin_get_type();
#define GDAM_TYPE_SPATIAL_STEREO_SKIN			(gdam_spatial_stereo_skin_get_type ())
#define GDAM_SPATIAL_STEREO_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SPATIAL_STEREO_SKIN, GdamSpatialStereoSkin))
#define GDAM_SPATIAL_STEREO_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SPATIAL_STEREO_SKIN, GdamSpatialStereoSkinClass))
#define GDAM_IS_SPATIAL_STEREO_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SPATIAL_STEREO_SKIN))
#define GDAM_IS_SPATIAL_STEREO_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SPATIAL_STEREO_SKIN))
typedef enum _GdamSpatialStereoDragMode {
	GDAM_SPATIAL_STEREO_DRAGGING_NONE,
	GDAM_SPATIAL_STEREO_DRAGGING_CENTER,
	GDAM_SPATIAL_STEREO_DRAGGING_LEFT,
	GDAM_SPATIAL_STEREO_DRAGGING_RIGHT,
	GDAM_SPATIAL_STEREO_DRAGGING_HEAD_CENTER,
	GDAM_SPATIAL_STEREO_DRAGGING_HEAD_LEFT,
	GDAM_SPATIAL_STEREO_DRAGGING_HEAD_RIGHT
} GdamSpatialStereoDragMode;


struct _GdamSpatialStereoSkinClass {
	GdamSkinClass		skin_class;
};
struct _GdamSpatialStereoSkin {
	GdamSkin			skin;

	int			drag_offset_x, drag_offset_y;

	int			head_center_radius;
	int			head_side_radius;
	int			output_center_radius;
	int			output_side_radius;
	GdkGC*			background;
	GdkGC*			circle_gc;

	gboolean		is_shift_dragging;
	GdamSpatialStereoDragMode drag_mode;

	GdkPixmap*		backing_pixmap;
	/* Height and width of the drawing area. */
	int			draw_width, draw_height;
	/* The drawing area for the samples... */
	GtkWidget*		drawing_area;

	/* The boundaries of the world. */
	gdouble			world_left, world_top;
	gdouble			world_width, world_height;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
