/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SPECTRUM_SCROLL_SKIN_H_
#define __GDAM_SPECTRUM_SCROLL_SKIN_H_


typedef struct _GdamSpectrumScrollSkin GdamSpectrumScrollSkin;
typedef struct _GdamSpectrumScrollSkinClass GdamSpectrumScrollSkinClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamskin.h"

GtkType gdam_spectrum_scroll_skin_get_type();
#define GDAM_TYPE_POWER_SPECTRUM_SKIN			(gdam_spectrum_scroll_skin_get_type ())
#define GDAM_SPECTRUM_SCROLL_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_POWER_SPECTRUM_SKIN, GdamSpectrumScrollSkin))
#define GDAM_SPECTRUM_SCROLL_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_POWER_SPECTRUM_SKIN, GdamSpectrumScrollSkinClass))
#define GDAM_IS_POWER_SPECTRUM_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_POWER_SPECTRUM_SKIN))
#define GDAM_IS_POWER_SPECTRUM_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_POWER_SPECTRUM_SKIN))

struct _GdamSpectrumScrollSkinClass {
	GdamSkinClass		skin_class;
};

struct _GdamSpectrumScrollSkin {
	GdamSkin		skin;

	GdkGC*			gray_family[16];
	GdkPixmap*		pixmap;
	int			start_x;
	int			start_y;
	int			draw_width;
	int			draw_height;
	gfloat			frequency_scale;
	gfloat			frequency_base;
	gfloat			normalization_level;
	gfloat			power_log_base;
	gfloat*			y_indices;

	GtkWidget*		drawing_area;

	gboolean		request_pending;
	guint			query_timeout_id;
	gboolean		swap_axes;
	gboolean		swap_direction;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
