/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAMSPINSKIN__H_
#define __GDAMSPINSKIN__H_

#include "../gdamechobaseskin.h"
#include <gdam/component/gdamecho.h>


typedef struct _GdamSpinSkinClass GdamSpinSkinClass;
typedef struct _GdamSpinSkin GdamSpinSkin;


GtkType gdam_spinskin_get_type();
#define GDAM_TYPE_SPINSKIN              (gdam_spinskin_get_type ())
#define GDAM_SPINSKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SPINSKIN, GdamSpinSkin))
#define GDAM_SPINSKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SPINSKIN, GdamSpinSkinClass))
#define GDAM_IS_SPINSKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SPINSKIN))
#define GDAM_IS_SPINSKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SPINSKIN))

struct _GdamSpinSkinClass {
	GdamEchoBaseSkinClass		base_class;
};


struct _GdamSpinSkin {
	GdamEchoBaseSkin		base;
};

#endif
