/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/

#if 0

#include "gdamsplinemapskin.h"
#include "../gdamskinutil.h"
#include "../../component/plugins/gdamsplinemap.h"
#include "../gtkcurve.h"

static void gdam_spline_map_skin_init(GdamSplineMapSkin* spline_map_skin)
{
}


static gboolean gdam_spline_map_add_plot_handler
				(GdamSkin*          skin,
			         GtkObject*         object,
			         const char*        signal_name,
			         int                num_args,
			         char**             command)
{
  GtkWidget *widget;
  GtkCurve *curve;
  gfloat vector[4] = { -1.0, -1.0, +1.0, +1.0 };
  widget = gtk_curve_new ();
  curve = GTK_CURVE (widget);
  gtk_container_add (GTK_CONTAINER (object), widget);
  gtk_curve_set_vector (curve, 2, vector);
  gtk_curve_set_range (curve, -1.0, +1.0, -1.0, +1.0);
  gtk_curve_set_curve_type (curve, GTK_CURVE_TYPE_SPLINE);
  gtk_widget_show (widget);
  return TRUE;
}

static GdamSkinGenericConnect connect_infos[] = {
	{ "gdam_spline_map_add_plot",
	   gdam_spline_map_add_plot_handler },
};

static void gdam_spline_map_skin_class_init(GdamSplineMapSkinClass* klass)
{
  GdamSkinClass *skin_class = GDAM_SKIN_CLASS (klass);
  gdam_skin_class_register_generic_handlers (skin_class,
					     G_N_ELEMENTS (connect_infos),
					     connect_infos);
  skin_class->model_type = GDAM_TYPE_SPLINE_MAP;
}

GtkType gdam_spline_map_skin_get_type()
{
  static GtkType spline_map_skin_type = 0;
  if (!spline_map_skin_type)
    {
      static const GtkTypeInfo spline_map_skin_info = {
	"GdamSplineMapSkin",
	sizeof (GdamSplineMapSkin),
	sizeof (GdamSplineMapSkinClass),
	(GtkClassInitFunc) gdam_spline_map_skin_class_init,
	(GtkObjectInitFunc) gdam_spline_map_skin_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      GtkType parent = GDAM_TYPE_SKIN;
      spline_map_skin_type = gtk_type_unique (parent, &spline_map_skin_info);
    }
  return spline_map_skin_type;
}

#endif
