/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_VOLUME_METER_SKIN_H_
#define __GDAM_VOLUME_METER_SKIN_H_

#include "../gdamskin.h"
#include <gtk/gtkprogressbar.h>

typedef struct _GdamVolumeMeterSkin GdamVolumeMeterSkin;
typedef struct _GdamVolumeMeterSkinClass GdamVolumeMeterSkinClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_volume_meter_skin_get_type();
#define GDAM_TYPE_VOLUME_METER_SKIN			(gdam_volume_meter_skin_get_type ())
#define GDAM_VOLUME_METER_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_VOLUME_METER_SKIN, GdamVolumeMeterSkin))
#define GDAM_VOLUME_METER_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_VOLUME_METER_SKIN, GdamVolumeMeterSkinClass))
#define GDAM_IS_VOLUME_METER_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_VOLUME_METER_SKIN))
#define GDAM_IS_VOLUME_METER_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_VOLUME_METER_SKIN))

struct _GdamVolumeMeterSkinClass {
	GdamSkinClass		skin_class;
};

struct _GdamVolumeMeterSkin {
	GdamSkin			skin;
	GtkProgressBar*			progress_bar;
	GtkProgressBar*			left_progress_bar;
	GtkProgressBar*			right_progress_bar;
	int				timer_id;
	int				timer_count;
	float				last_vol;
	float				target_vol;
	gboolean			had_source_id,
					request_pending;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
